import { Schema } from 'fast-json-stringify';
import { C as CompilationContext } from './index-94yATZqY.mjs';
import '@graphql-typed-document-node/core';
import 'graphql';
import 'graphql/execution/execute';
import 'graphql/language/ast';
import 'graphql/type/definition';
import 'graphql/jsutils/Maybe';
import 'graphql/error';
import './error.mjs';
import './resolve-info.mjs';
import './types.mjs';
import './variables.mjs';

/**
 * GQL -> JSON Schema transform
 *
 * @param compilationContext
 * @return     {object}  A plain JavaScript object which conforms to JSON Schema
 */
declare function queryToJSONSchema(compilationContext: CompilationContext): Schema;

export { queryToJSONSchema };
